﻿using C1.Win.C1FlexGrid;
using C1.Win.C1SuperTooltip;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace FgCellLabels
{
    public partial class Form1 : Form
    {
        private C1SuperTooltip toolTip1;
        C1.Win.C1SuperTooltip.C1SuperLabel _html = new C1.Win.C1SuperTooltip.C1SuperLabel();

        public Form1()
        {
            InitializeComponent();
            toolTip1 = new C1SuperTooltip();
            toolTip1.Popup += ToolTip1_Popup;
            flex.MouseMove += C1FlexGrid1_MouseMove;
            flex.AllowResizing = AllowResizingEnum.Both;
            flex.DrawMode = DrawModeEnum.OwnerDraw;
            flex.OwnerDrawCell += Flex_OwnerDrawCell;

            flex[1, 1] = "this is a <a href=\"www.google.com\">google link";
            flex[2, 1] = "This is <i>italic</i> text in an HTML string";
            flex[3, 1] = "This is a some long <b>Text</b> with some <I>HTML</I> with a <a href=\"www.Grapecity.com\">grapecity link</a>";
        }

        private void ToolTip1_Popup(object sender, C1.Win.C1SuperTooltip.PopupEventArgs e)
        {
            HitTestInfo info = flex.HitTest();
            if (info.Row < 0 || info.Column < 0)
            {
                return;
            }
            C1SuperTooltip toolTip = sender as C1SuperTooltip;
            _html.Text = flex.GetDataDisplay(info.Row,info.Column);
            var rect = flex.GetCellRect(info.Row, info.Column);
            //Measure Content of C1SuperLabel 
            Size sz = _html.Measure(rect.Width);
            e.Location = flex.RectangleToScreen(rect).Location;
           
            //check if the content exceeds Height since the Text will be word wrapped
            if (sz.Height <= rect.Height)
            {
                e.Cancel = true;
            }
            
            
        }

        private void Flex_OwnerDrawCell(object sender, C1.Win.C1FlexGrid.OwnerDrawCellEventArgs e)
        {
            if (e.Col == 1)
            {
                // draw background
                e.DrawCell(DrawCellFlags.Background);

                // use the C1SuperLabel to draw the html text
                if (e.Bounds.Width > 0 && e.Bounds.Height > 0)
                {
                    _html.Text = flex.GetDataDisplay(e.Row, e.Col);
                    _html.BackColor = Color.Transparent;
                    _html.DrawToGraphics(e.Graphics, e.Bounds);
                }

                // and draw border last
                e.DrawCell(DrawCellFlags.Border);

                // we're done with this cell
                e.Handled = true;
            }
        }

        private void C1FlexGrid1_MouseMove(object sender, MouseEventArgs e)
        {
            HitTestInfo info = flex.HitTest();
            if (info.Row > 0 && info.Column > 0)
            {
                //set tool tips
                string tip = flex.GetDataDisplay(flex.MouseRow, flex.MouseCol);
                toolTip1.SetToolTip(flex, tip);
            }
        }
    }
}
